## START: Set by rpmautospec
## (rpmautospec version 0.7.3)
## RPMAUTOSPEC: autorelease, autochangelog
%define autorelease(e:s:pb:n) %{?-p:0.}%{lua:
    release_number = 1;
    base_release_number = tonumber(rpm.expand("%{?-b*}%{!?-b:1}"));
    print(release_number + base_release_number - 1);
}%{?-e:.%{-e*}}%{?-s:.%{-s*}}%{!?-n:%{?dist}}
## END: Set by rpmautospec

Name:		gzdoom
Version:	4.14.0
Release:	%autorelease
Summary:	GZDoom is a feature centric port for all Doom engine games

License:	GPL-3.0-or-later and LGPL-3.0-or-later and MIT and BSD-3-Clause
URL:		https://github.com/ZDoom/gzdoom
Source0:	%{url}/archive/refs/tags/g%{version}.tar.gz
Source1:	gzdoom.desktop
Source2:	gzdoom.metainfo.xml

BuildRequires:	g++
BuildRequires:	cmake
BuildRequires:	bzip2-devel
BuildRequires:	libvpx-devel
BuildRequires:	gtk3-devel
BuildRequires:	openal-soft-devel
BuildRequires:	SDL2-devel
BuildRequires:	zmusic-devel

BuildRequires:	sed
BuildRequires:	desktop-file-utils
BuildRequires:	libappstream-glib
BuildRequires:	ImageMagick

# asmjit bundled version is heavily modified, FORCE_BUNDLED_ASMJIT is ignored
Provides:	bundled(asmjit)		= 1.0.0
Provides:	bundled(discordrpc)
Provides:	bundled(lzma-sdk)	= 21.07
Provides:	bundled(miniz)		= 3.0.0
Provides:	bundled(libwebp)	= 1.3.2

%global debug_package %{nil}

%description
GZDoom is a feature centric port for all Doom engine games, based on ZDoom,
adding an OpenGL renderer and powerful scripting capabilities

%prep
%autosetup -p1 -n %{name}-g%{version}

rm -rf libraries/bzip2

# DUMB is applicable to ZMusic
rm docs/licenses/dumb.txt

# show actual version instead of "<unknown version>"
sed -i "s/<unknown version>/g%{version}/" tools/updaterevision/UpdateRevision.cmake

# reproducible builds
sed -i "s/__DATE__/\"$SOURCE_DATE_EPOCH\"/" src/common/platform/posix/sdl/i_main.cpp


%build
# doesn't build without it using RHEL flags :shrug:
export COMMON_FLAGS="-fPIC"

%cmake  -DCMAKE_BUILD_TYPE=Release			\
        -DCMAKE_C_FLAGS="$COMMON_FLAGS"         	\
        -DCMAKE_CXX_FLAGS="$COMMON_FLAGS"       	\
	-DINSTALL_PK3_PATH=%{_datadir}/doom		\
	-DINSTALL_SOUNDFONT_PATH=%{_datadir}/doom	\
	-DINSTALL_DOCS_PATH=%{_pkgdocdir}		\
        -DDYN_OPENAL=OFF                        	\
	-DDYN_GTK=OFF					\
	-DBUILD_SHARED_LIBS=OFF                 	\
        -DFORCE_INTERNAL_BZIP2=OFF
	
%cmake_build

%install
%cmake_install

rm -rf %{buildroot}%{_pkgdocdir}/licenses

desktop-file-install --dir %{buildroot}%{_datadir}/applications %{SOURCE1}

install -m 0755 -vd %{buildroot}%{_metainfodir}
install -m 0644 -vpT %{SOURCE2} %{buildroot}%{_metainfodir}/gzdoom.metainfo.xml

for size in 16 32 64 128 256; do
	dest=%{buildroot}%{_datadir}/icons/hicolor/${size}x${size}/apps

	mkdir -p $dest
	magick src/posix/zdoom.xpm $dest/%{name}.png
done


%check
%ctest

desktop-file-validate %{buildroot}/%{_datadir}/applications/gzdoom.desktop
appstream-util validate-relax --nonet %{buildroot}%{_metainfodir}/gzdoom.metainfo.xml

%files
%license docs/licenses/*
%doc %{_pkgdocdir}
%{_bindir}/gzdoom
%{_datadir}/doom/*
%{_datadir}/icons/hicolor/*/apps/gzdoom.png
%{_datadir}/applications/gzdoom.desktop
%{_metainfodir}/gzdoom.metainfo.xml


%changelog
## START: Generated by rpmautospec
* Tue Dec 24 2024 John Doe <packager@example.com> - 4.14.0-1
- Uncommitted changes
## END: Generated by rpmautospec
